
package de.ivu.elect.business.wahl.boundary;

import javax.inject.Inject;

import de.ivu.elect.business.wahl.entity.Wahltermin;

// abgeleitete Klasse mit "@javax.ejb.Stateless" annotieren!
public abstract class AbstractWahlterminEdit {

  @Inject
  protected WahlterminDAO dao;

  @Inject
  protected WahlterminExtendedDAO extendedDao;

  public void delete(Wahltermin entity) {
    dao.remove(getAttachedEntity(entity));
  }

  public void save(Wahltermin entity) {
    validate(entity);

    flushToSave();
  }

  protected void validate(Wahltermin entity) {
    // Do nothing by default.
  }

  protected void flushToSave() {
    if(usesMixedTransactionalContexts()) {
        extendedDao.flushNewTransaction();
    } else {
        extendedDao.flush();
    }
  }

  // ELECT-945
  protected boolean usesMixedTransactionalContexts() {
    return false;
  }

  protected Wahltermin getAttachedEntity(Wahltermin entity) {
    return dao.findByPrimaryKey(entity.getPk());
  }

  // Cf. ELECT-3187 (Änderungen an Entität werden nicht gespeichert)
  protected Wahltermin getAttachedAndRefreshedEntity(Wahltermin entity) {
    return dao.refresh(entity);
  }
}
